/*----------------------------------------------------------------------------*/
/* lld_DIO.c                                                05/24/11 09:45:48 */
/*                                                                            */
/* (c) Texas Instruments 2003-2011, All rights reserved.                      */
/*                                                                            */
/* Versions:                                                                  */
/* HALCOGEN         2.07.007                                                  */
/* OCDIOx470        1.01.000                                                  */
/* TICGEN           2.01.000                                                  */
/*                                                                            */


#include "sys_types.h"
#include "sys_common.h"
#include "lld_DIO.h"

/*----------------------------------------------------------------------------*/

/* USER CODE BEGIN (0) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* OCDIO_InitSync                                                             */

/* USER CODE BEGIN (1) */
/* USER CODE END */

IO_ErrorType OCDIO_InitSync(OCDIO_ConfigType config)
{
/* USER CODE BEGIN (2) */
/* USER CODE END */

    /* take DIO module out of reset state */
    OCDIO->GCR0 = 1U;

    /* initalise port 0 */
/*
    OCDIO0->DOUT   = 0x00000004U;
    OCDIO0->DIR    = 0x00000006U;
    OCDIO0->PDR    = 0x00000000U;
    OCDIO0->PULDIS = 0x000000FFU;
    OCDIO0->PSL    = 0x00000000U;
*/
    OCDIO0->DOUT   = 0x00000000U;
    OCDIO0->DIR    = 0x00000001U;
    OCDIO0->PDR    = 0x00000000U;
    OCDIO0->PULDIS = 0x000000FFU;
    OCDIO0->PSL    = 0x00000000U;

    /* initalise interrupt registers */
    OCDIO->LVLCLR    = 0xFFFFFFFFU;
    OCDIO->LVLSET    = 0x00000000U;
    OCDIO->INTENACLR = 0xFFFFFFFFU;
    OCDIO->FLG       = 0xFFFFFFFFU;
//  OCDIO->POL       = 0x0000FFFFU;
    OCDIO->POL       = 0x000000FFU;
    OCDIO->INTDET    = 0x00000000U;

/* USER CODE BEGIN (3) */
/* USER CODE END */

    return IO_E_OK;
}


/*----------------------------------------------------------------------------*/
/* OCDIO_DeInitSync                                                           */

/* USER CODE BEGIN (4) */
/* USER CODE END */

void OCDIO_DeInitSync(void)
{
/* USER CODE BEGIN (5) */
/* USER CODE END */

    /* reset DIO module */
    OCDIO->GCR0 = 0U;

/* USER CODE BEGIN (6) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* OCDIO_GetSync                                                              */

/* USER CODE BEGIN (10) */
/* USER CODE END */

OCDIO_ValueType OCDIO_GetSync(IO_ChannelType channel)
{
    OCDIO_ValueType value;

/* USER CODE BEGIN (11) */
/* USER CODE END */

    value = OCDIO0->DIN & (0x01U << channel);

/* USER CODE BEGIN (12) */
/* USER CODE END */

    return value ? IO_HIGH : IO_LOW;
}


/*----------------------------------------------------------------------------*/
/* OCDIO_SetSync                                                              */

/* USER CODE BEGIN (13) */
/* USER CODE END */

void OCDIO_SetSync(IO_ChannelType channel, OCDIO_ValueType value)
{
/* USER CODE BEGIN (14) */
/* USER CODE END */

    if (value)
    {
        OCDIO0->DSET = 0x01U << channel;
    }
    else
    {
        OCDIO0->DCLR = 0x01U << channel;
    }

/* USER CODE BEGIN (15) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* OCDIO_GetPortSync                                                          */

/* USER CODE BEGIN (16) */
/* USER CODE END */

OCDIO_ValueType OCDIO_GetPortSync(IO_ChannelType port)
{
    OCDIO_ValueType value;

/* USER CODE BEGIN (17) */
/* USER CODE END */

    value = OCDIO0->DIN;

/* USER CODE BEGIN (18) */
/* USER CODE END */

    return value;
}


/*----------------------------------------------------------------------------*/
/* OCDIO_SetPortSync                                                          */

/* USER CODE BEGIN (19) */
/* USER CODE END */

void OCDIO_SetPortSync(IO_ChannelType port, OCDIO_ValueType value)
{
/* USER CODE BEGIN (20) */
/* USER CODE END */

    OCDIO0->DOUT = value;

/* USER CODE BEGIN (21) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* OCDIO_SetPortMaskedSync                                                    */

/* USER CODE BEGIN (22) */
/* USER CODE END */

void OCDIO_SetPortMaskedSync(IO_ChannelType port, OCDIO_ValueType value, OCDIO_ValueType mask)
{
/* USER CODE BEGIN (23) */
/* USER CODE END */

    OCDIO0->DSET = value & mask;
    OCDIO0->DCLR = ~value & mask;

/* USER CODE BEGIN (24) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* OCDIO_EnableNotification                                                   */

/* USER CODE BEGIN (25) */
/* USER CODE END */

void OCDIO_EnableNotification(IO_ChannelType channel, OCDIO_ValueType notifType)
{
/* USER CODE BEGIN (26) */
/* USER CODE END */

    switch (notifType)
    {
    case IO_N_ALL:
        OCDIO->INTDET |= 0x01U << channel;
        break;

    case IO_N_RISING_EDGE:
        OCDIO->INTDET &= ~(0x01U << channel);
        OCDIO->POL |= 0x01U << channel;
        break;

    case IO_N_FALLING_EDGE:
        OCDIO->INTDET &= ~(0x01U << channel);
        OCDIO->POL &= ~(0x01U << channel);
        break;

    default:
        break;
    }

    OCDIO->INTENASET = 0x01U << channel;

/* USER CODE BEGIN (27) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* OCDIO_DisableNotification                                                  */

/* USER CODE BEGIN (28) */
/* USER CODE END */

void OCDIO_DisableNotification(IO_ChannelType channel, OCDIO_ValueType notifType)
{
/* USER CODE BEGIN (29) */
/* USER CODE END */

    OCDIO->INTENACLR = 0x01U << channel;

/* USER CODE BEGIN (30) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* DIO - Interrupt Service Routine for high priority                          */

/* USER CODE BEGIN (31) */
/* USER CODE END */

#pragma INTERRUPT(gioHighLevelInterrupt,IRQ)

void gioHighLevelInterrupt()
{
    T_S32 offset = (T_S32)(OCDIO->OFFSET0 - 1U);

/* USER CODE BEGIN (32) */
/* USER CODE END */

    if (offset >= 0)
    {
        T_U32 bitmask = 1 << offset;

        if (OCDIO->INTDET & bitmask)
        {
            OCDIO_Notification((T_U32)offset, IO_N_ALL);
        }
        else if (OCDIO->POL & bitmask)
        {
            OCDIO_Notification((T_U32)offset, IO_N_RISING_EDGE);
        }
        else
        {
            OCDIO_Notification((T_U32)offset, IO_N_FALLING_EDGE);
        }
    }

/* USER CODE BEGIN (33) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* DIO - Interrupt Service Routine for low priority                           */

/* USER CODE BEGIN (34) */
/* USER CODE END */

#pragma INTERRUPT(gioLowLevelInterrupt,IRQ)

void gioLowLevelInterrupt()
{
    T_S32 offset = (T_S32)(OCDIO->OFFSET1 - 1U);

/* USER CODE BEGIN (35) */
/* USER CODE END */

    if (offset >= 0)
    {
        T_U32 bitmask = 1 << offset;

        if (OCDIO->INTDET & bitmask)
        {
            OCDIO_Notification((T_U32)offset, IO_N_ALL);
        }
        else if (OCDIO->POL & bitmask)
        {
            OCDIO_Notification((T_U32)offset, IO_N_RISING_EDGE);
        }
        else
        {
            OCDIO_Notification((T_U32)offset, IO_N_FALLING_EDGE);
        }
    }

/* USER CODE BEGIN (36) */
/* USER CODE END */
}


/* USER CODE BEGIN (149) */
/* USER CODE END */

/*----------------------------------------------------------------------------*/

