/*----------------------------------------------------------------------------*/
/* lld_DIO.h                                                05/24/11 09:45:48 */
/*                                                                            */
/* (c) Texas Instruments 2003-2011, All rights reserved.                      */
/*                                                                            */
/* Versions:                                                                  */
/* HALCOGEN         2.07.007                                                  */
/* OCDIOx470        1.01.000                                                  */
/* TICGEN           2.01.000                                                  */
/*                                                                            */


#ifndef __lld_DIO_h__
#define __lld_DIO_h__

/* USER CODE BEGIN (0) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* OCDIO configuration                                                        */

#define OCDIO_MAX_PORT         0x00000001U
#define OCDIO_MAX_CHANNEL      0x00000107U

/* USER CODE BEGIN (1) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* Definitions                                                                */

/* Port 0 */
#define OCDIO_PORT_0 0U

#define OCDIO_0 0x00000000U
#define OCDIO_1 0x00000001U
#define OCDIO_2 0x00000002U


/* USER CODE BEGIN (2) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* Data Types                                                                 */

typedef       T_U32  OCDIO_ValueType;
typedef const void * OCDIO_ConfigType;

/* USER CODE BEGIN (3) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* DIO register definition                                                    */

typedef volatile struct
{
    T_U32 GCR0;      /* 0x0000 */
    T_U32 PWDN;      /* 0x0004 */
    T_U32 INTDET;    /* 0x0008 */
    T_U32 POL;       /* 0x000C */
    T_U32 INTENASET; /* 0x0010 */
    T_U32 INTENACLR; /* 0x0014 */
    T_U32 LVLSET;    /* 0x0018 */
    T_U32 LVLCLR;    /* 0x001C */
    T_U32 FLG;       /* 0x0020 */
    T_U32 OFFSET0;   /* 0x0024 */
    T_U32 OFFSET1;   /* 0x0028 */
    T_U32 EMUA;      /* 0x002C */
    T_U32 EMUB;      /* 0x0030 */
} T_OCDIO_REG;

#define OCDIO ((T_OCDIO_REG  *)0xFFF7BC00U)


typedef volatile struct
{
    T_U32 DIR;    /* 0x0000 */
    T_U32 DIN;    /* 0x0004 */
    T_U32 DOUT;   /* 0x0008 */
    T_U32 DSET;   /* 0x000C */
    T_U32 DCLR;   /* 0x0010 */
    T_U32 PDR;    /* 0x0014 */
    T_U32 PULDIS; /* 0x0018 */
    T_U32 PSL;    /* 0x001C */
} T_OCDIO_PORT;

#define OCDIO0 ((T_OCDIO_PORT *)0xFFF7BC34U)



/*----------------------------------------------------------------------------*/
/* Global Variables                                                           */

extern T_OCDIO_PORT * const g_OCDIO_base[];

/* USER CODE BEGIN (4) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* inline functions                                                           */

/* OCDIO_GetVersionOfDriver */
static inline IO_U32 OCDIO_GetVersionOfDriver()
{
    return 0x00140100U;
}

/* USER CODE BEGIN (5) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* DIO interface functions                                                    */

IO_ErrorType OCDIO_InitSync(OCDIO_ConfigType config);
void OCDIO_DeInitSync(void);
OCDIO_ValueType OCDIO_GetSync(IO_ChannelType channel);
void OCDIO_SetSync(IO_ChannelType channel, OCDIO_ValueType value);
OCDIO_ValueType OCDIO_GetPortSync(IO_ChannelType port);
void OCDIO_SetPortSync(IO_ChannelType port, OCDIO_ValueType value);
void OCDIO_SetPortMaskedSync(IO_ChannelType port, OCDIO_ValueType value, OCDIO_ValueType mask);
void OCDIO_EnableNotification(IO_ChannelType channel, OCDIO_ValueType notifType);
void OCDIO_DisableNotification(IO_ChannelType channel, OCDIO_ValueType notifType);
void OCDIO_Notification(IO_ChannelType channel, OCDIO_ValueType notifType);

/* USER CODE BEGIN (149) */
/* USER CODE END */


#endif
/*----------------------------------------------------------------------------*/

