/*----------------------------------------------------------------------------*/
/* lld_TIM.c                                                05/24/11 09:45:48 */
/*                                                                            */
/* (c) Texas Instruments 2003-2011, All rights reserved.                      */
/*                                                                            */
/* Versions:                                                                  */
/* HALCOGEN         2.07.007                                                  */
/* OCTIMx470        2.02.000                                                  */
/* TICGEN           2.01.000                                                  */
/*                                                                            */


#include "sys_types.h"
#include "sys_common.h"
#include "lld_TIM.h"

/*----------------------------------------------------------------------------*/

/* USER CODE BEGIN (0) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* Global Variables                                                           */


/*----------------------------------------------------------------------------*/
/* OCTIM_InitSync                                                             */

/* USER CODE BEGIN (1) */
/* USER CODE END */


IO_ErrorType OCTIM_InitSync(const void * address)
{
/* USER CODE BEGIN (2) */
/* USER CODE END */

    /* initalise RTI module 0 */
    OCRTI0->GCTRL         = 0x00000000U;
    OCRTI0->TBCTRL        = 0x00000000U;
    OCRTI0->COMPCTRL      = 0x00000010U;
    OCRTI0->CNT[0U].UCx   = 0x00000000U;
    OCRTI0->CNT[0U].FRCx  = 0x00000000U;
    OCRTI0->CNT[0U].CPUCx = 0x00000001U;
    OCRTI0->CMP[0U].COMPx = 0xFFFFFFFFU;
    OCRTI0->CMP[0U].UDCPx = 0x00000000U;
    OCRTI0->INTFLAG       = 0x0007000FU;
    OCRTI0->CLEARINT      = 0x00070F0FU;

/* USER CODE BEGIN (3) */
/* USER CODE END */

    return IO_E_OK;
}


/*----------------------------------------------------------------------------*/
/* OCTIM_DeInitSync                                                           */

/* USER CODE BEGIN (4) */
/* USER CODE END */

IO_ErrorType OCTIM_DeInitSync(const void * address)
{
/* USER CODE BEGIN (5) */
/* USER CODE END */

    /* reset RTI module 0 */
    OCRTI0->GCTRL         = 0x00000000U;
    OCRTI0->TBCTRL        = 0x00000000U;
    OCRTI0->COMPCTRL      = 0x00000000U;
    OCRTI0->CNT[0U].UCx   = 0x00000000U;
    OCRTI0->CNT[0U].FRCx  = 0x00000000U;
    OCRTI0->CNT[0U].CPUCx = 0x00000000U;
    OCRTI0->CMP[0U].COMPx = 0x00000000U;
    OCRTI0->CMP[0U].UDCPx = 0x00000000U;
    OCRTI0->INTFLAG       = 0x0007000FU;
    OCRTI0->CLEARINT      = 0x00070F0FU;

/* USER CODE BEGIN (6) */
/* USER CODE END */

    return IO_E_OK;
}


/*----------------------------------------------------------------------------*/
/* OCTIM_GetSync                                                              */

/* USER CODE BEGIN (7) */
/* USER CODE END */

OCTIM_ValueType OCTIM_GetSync(IO_ChannelType channel)
{
    OCTIM_ValueType value;

/* USER CODE BEGIN (8) */
/* USER CODE END */

//orig//    value = OCRTI0->CMP[channel].COMPx - OCRTI0->CNT[channel].FRCx;
    value = OCRTI0->CNT[channel].FRCx;

/* USER CODE BEGIN (9) */
/* USER CODE END */

    return value;
}


/*----------------------------------------------------------------------------*/
/* OCTIM_SetSync                                                              */

/* USER CODE BEGIN (10) */
/* USER CODE END */

void OCTIM_SetSync(IO_ChannelType channel, OCTIM_ValueType value)
{
/* USER CODE BEGIN (11) */
/* USER CODE END */

    if (OCRTI0->GCTRL & (1U << channel))
    {
        return;
    }

    OCRTI0->CMP[channel].COMPx = OCRTI0->CMP[channel].UDCPx - value + OCRTI0->CNT[channel].FRCx;

/* USER CODE BEGIN (12) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* OCTIM_SetPeriodSync                                                        */

/* USER CODE BEGIN (13) */
/* USER CODE END */

void OCTIM_SetPeriodSync(IO_ChannelType channel, OCTIM_ValueType value)
{
/* USER CODE BEGIN (14) */
/* USER CODE END */

    if (OCRTI0->GCTRL & (1U << channel))
    {
        return;
    }

    OCRTI0->CMP[channel].UDCPx = value;

/* USER CODE BEGIN (15) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* OCTIM_StartSync                                                            */

/* USER CODE BEGIN (16) */
/* USER CODE END */

void OCTIM_StartSync(IO_ChannelType channel)
{
/* USER CODE BEGIN (17) */
/* USER CODE END */

    OCRTI0->GCTRL |= (1U << channel);

/* USER CODE BEGIN (18) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* OCTIM_StopSync                                                             */

/* USER CODE BEGIN (19) */
/* USER CODE END */

void OCTIM_StopSync(IO_ChannelType channel)
{
/* USER CODE BEGIN (20) */
/* USER CODE END */

    OCRTI0->GCTRL &= ~(1U << channel);

/* USER CODE BEGIN (21) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* OCTIM_EnableNotification                                                   */

/* USER CODE BEGIN (22) */
/* USER CODE END */

void OCTIM_EnableNotification(IO_ChannelType channel, OCTIM_ValueType notifType)
{
/* USER CODE BEGIN (23) */
/* USER CODE END */

    OCRTI0->SETINT = 1U << channel;

/* USER CODE BEGIN (24) */
/* USER CODE END */
}


/*----------------------------------------------------------------------------*/
/* OCTIM_DisableNotification                                                  */

/* USER CODE BEGIN (25) */
/* USER CODE END */

void OCTIM_DisableNotification(IO_ChannelType channel, OCTIM_ValueType notifType)
{
/* USER CODE BEGIN (26) */
/* USER CODE END */

    OCRTI0->CLEARINT = 1U << channel;

/* USER CODE BEGIN (27) */
/* USER CODE END */
}


/* USER CODE BEGIN (149) */
/* USER CODE END */

/*----------------------------------------------------------------------------*/

