/*----------------------------------------------------------------------------*/
/* lld_TIM.h                                                05/24/11 09:45:48 */
/*                                                                            */
/* (c) Texas Instruments 2003-2011, All rights reserved.                      */
/*                                                                            */
/* Versions:                                                                  */
/* HALCOGEN         2.07.007                                                  */
/* OCTIMx470        2.02.000                                                  */
/* TICGEN           2.01.000                                                  */
/*                                                                            */


#ifndef __lld_TIM_h__
#define __lld_TIM_h__

/* USER CODE BEGIN (0) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* OCTIM configuration                                                        */

#define OCTIM_MAX_PORT    0U
#define OCTIM_MAX_CHANNEL 2U

/* USER CODE BEGIN (1) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* Definitions                                                                */

#define OCTIM_E_NOT_PRIVILEDGE_MODE 100U

#define OCTIM_0 0U

/* USER CODE BEGIN (2) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* Data Types                                                                 */

typedef T_U32 OCTIM_ValueType;


/*----------------------------------------------------------------------------*/
/* RTI register definition                                                    */

typedef volatile struct
{
    T_U32 GCTRL;
    T_U32 TBCTRL;
    T_U32 CAPCTRL;
    T_U32 COMPCTRL;
    struct
    {
        T_U32 FRCx;
        T_U32 UCx;
        T_U32 CPUCx;
        T_U32 : 32;
        T_U32 CAFRCx;
        T_U32 CAUCx;
        T_U32 : 32;
        T_U32 : 32;
    } CNT[2U];
    struct
    {
        T_U32 COMPx;
        T_U32 UDCPx;
    } CMP[4U];
    T_U32 TBLCOMP;
    T_U32 TBHCOMP;
    T_U32 : 32;
    T_U32 : 32;
    T_U32 SETINT;
    T_U32 CLEARINT;
    T_U32 INTFLAG;
    T_U32 : 32;
    T_U32 DWDCTRL;
    T_U32 DWDPRLD;
    T_U32 WDSTATUS;
    T_U32 WDKEY;
    T_U32 WDCNTR;
} T_OCRTI;

#define OCRTI0 ((T_OCRTI *)0xFFFFFC00U)

/* USER CODE BEGIN (3) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* inline functions                                                           */

/* USER CODE BEGIN (4) */
/* USER CODE END */


/*----------------------------------------------------------------------------*/
/* TIM interface functions                                                    */

IO_ErrorType OCTIM_InitSync(const void * address);
IO_ErrorType OCTIM_DeInitSync(const void * address);
OCTIM_ValueType OCTIM_GetSync(IO_ChannelType channel);
void OCTIM_SetSync(IO_ChannelType channel, OCTIM_ValueType value);
void OCTIM_SetPeriodSync(IO_ChannelType channel, OCTIM_ValueType value);
void OCTIM_StartSync(IO_ChannelType channel);
void OCTIM_StopSync(IO_ChannelType channel);
void OCTIM_EnableNotification(IO_ChannelType channel, OCTIM_ValueType notifType);
void OCTIM_DisableNotification(IO_ChannelType channel, OCTIM_ValueType notifType);
void OCTIM_Notification(IO_ChannelType channel, OCTIM_ValueType notifType);

/* USER CODE BEGIN (149) */
/* USER CODE END */

#endif
/*----------------------------------------------------------------------------*/

